/* The following code example is taken from the book
 * "The C++ Standard Library - A Tutorial and Reference, 2nd Edition"
 * by Nicolai M. Josuttis, Addison-Wesley, 2012
 *
 * (C) Copyright Nicolai M. Josuttis 2012.
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 */
#include "algostuff.hpp"
using namespace std;

int main()
{
    list<int> coll;

    INSERT_ELEMENTS(coll,1,9);
    INSERT_ELEMENTS(coll,1,9);
    coll.sort ();
    PRINT_ELEMENTS(coll);

    // wypisz pierwszą i ostatnią pozycję, na której mogłaby zostać wstawiona wartość 5
    auto pos1 = lower_bound (coll.cbegin(), coll.cend(),
                             5);
    auto pos2 = upper_bound (coll.cbegin(), coll.cend(),
                             5);

    cout << "wartość 5 mogłaby otrzymać pozycję od "
         << distance(coll.cbegin(),pos1) + 1
         << " do "
         << distance(coll.cbegin(),pos2) + 1
         << " bez naruszania uporządkowania" << endl;

    // wstaw wartość 3 na pierwszej możliwej pozycji bez naruszania uporządkowania
    coll.insert (lower_bound(coll.begin(),coll.end(),
                             3),
                 3);

    // wstaw wartość 7 na pierwszej możliwej pozycji bez naruszania uporządkowania
    coll.insert (upper_bound(coll.begin(),coll.end(),
                             7),
                 7);

    PRINT_ELEMENTS(coll);
}
