/* The following code example is taken from the book
 * "The C++ Standard Library - A Tutorial and Reference, 2nd Edition"
 * by Nicolai M. Josuttis, Addison-Wesley, 2012
 *
 * (C) Copyright Nicolai M. Josuttis 2012.
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 */
#include <iostream>
#include <string>
#include <algorithm>
#include <iterator>
#include <vector>
using namespace std;

int main()
{
    // utwórz wektor łańcuchów
    // - inicjalizowany wszystkimi słowami z wejścia standardowego
    vector<string> coll((istream_iterator<string>(cin)),
                        (istream_iterator<string>()));

    // posortuj elementy
    sort (coll.begin(), coll.end());

    // wypisz wszystkie elementy z pominięciem kolejnych elementów powtarzających się
    unique_copy (coll.begin(), coll.end(),
                 ostream_iterator<string>(cout, "\n"));
}
