/* The following code example is taken from the book
 * "The C++ Standard Library - A Tutorial and Reference, 2nd Edition"
 * by Nicolai M. Josuttis, Addison-Wesley, 2012
 *
 * (C) Copyright Nicolai M. Josuttis 2012.
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 */
#include <iostream>
#include <queue>
#include <string>
using namespace std;

int main()
{
    queue<string> q;

    // wstawia do kolejki trzy elementy
    q.push("To ");
    q.push("są ");
    q.push("więcej niż ");

    // odczytuje z kolejki dwa elementy i je wypisuje
    cout << q.front();
    q.pop();
    cout << q.front();
    q.pop();

    // wstawia nowe elementy
    q.push("cztery ");
    q.push("słowa!");

    // pomija jeden element
    q.pop();

    // odczytuje i wypisuje dwa elementy
    cout << q.front();
    q.pop();
    cout << q.front() << endl;
    q.pop();

    // wypisuje liczbe elementow w kolejce
    cout << "liczba elementów w kolejce: " << q.size()
         << endl;
}
